unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Comm32, DB, DBTables, StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    tblProd: TTable;
    lblInData: TLabel;
    cmdExit: TButton;
    tmrPollComA: TTimer;
    lblUnit: TLabel;
    lblComp: TLabel;
    lblTitleUnit: TLabel;
    lblTitleComp: TLabel;
    lblTo9512: TLabel;
    lblTitle9512: TLabel;
    lblScanCount: TLabel;

    procedure Save_Data(ParseData: String);
    function GetToken(aString, SepChar: String; TokenNum: Byte):String;
    function NumToken(aString, SepChar: String):Byte;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdExitClick(Sender: TObject);
    procedure tmrPollComATimer(Sender: TObject);
    procedure ReadCommData;
    procedure Write_9512_Data(strUnitSerialNumber: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  hCommIn: THandle;
  hCommOut: THandle;
  intScanCount: Integer = 0;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
var dcbIn: Tdcb;
    dcbOut: Tdcb;
    comErr: DWORD;
    flgOpStatus: Boolean;
begin
  tblProd.active := True;

  // Open the Input Com Port and check for errors!
  try
    hCommIn := CreateFile('COM1',GENERIC_READ + GENERIC_WRITE,FILE_SHARE_READ + FILE_SHARE_WRITE,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error OPENING Serial Port  - Call MIS!', mtError,[mbOK], 0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if hCommIn = INVALID_HANDLE_VALUE then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' OPENING Serial Port  - Call MIS!', mtError,[mbOK], 0);
    end;

  try
    flgOpStatus := GetCommState(hCommIn,dcbIn);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during GetCommState - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during GetCommState - Call MIS!', mtError,[mbOK],0);
        close;
    end;

  dcbIn.flags := dcbIn.flags OR $01;

  try
      flgOpStatus := BuildCommDCB('COM1: 96,E,7,1,x',dcbIn);
    except
      on X: EAccessViolation do
        begin
          MessageDlg('EAccessViolation Error during BuildCommDCB - Call MIS!', mtError,[mbOK],0);
          close;
        end
      else
        begin
          raise;
          close;
        end;
    end;

    if flgOpStatus = false then
      begin
        comErr := GetLastError();
        MessageDlg('Error #' + inttostr(comErr) + ' during BuildCommDCB - Call MIS!',mtError,[mbOK], 0);
        close;
      end;

  try
    flgOpStatus := SetCommMask(hCommIn,EV_RXCHAR);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during SetCommMask - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during SetCommMask - Call MIS!',mtError,[mbOK], 0);
      close;
    end;


  try
    flgOpStatus := SetCommState(hCommIn,dcbIn);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during SetCommState - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during SetCommState - Call MIS!',mtError,[mbOK], 0);
      close;
    end;

  // Open the Output Com Port and check for errors!
  try
    hCommOut := CreateFile('COM2',GENERIC_READ + GENERIC_WRITE,FILE_SHARE_READ + FILE_SHARE_WRITE,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error OPENING Serial Port  - Call MIS!', mtError,[mbOK], 0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if hCommOut = INVALID_HANDLE_VALUE then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' OPENING Serial Port  - Call MIS!', mtError,[mbOK], 0);
    end;

  try
    flgOpStatus := GetCommState(hCommOut,dcbOut);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during GetCommState - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during GetCommState - Call MIS!', mtError,[mbOK],0);
        close;
    end;

  dcbOut.flags := dcbOut.flags OR $01;

  try
      flgOpStatus := BuildCommDCB('COM2: 96,E,7,1,x',dcbOut);
    except
      on X: EAccessViolation do
        begin
          MessageDlg('EAccessViolation Error during BuildCommDCB - Call MIS!', mtError,[mbOK],0);
          close;
        end
      else
        begin
          raise;
          close;
        end;
    end;

    if flgOpStatus = false then
      begin
        comErr := GetLastError();
        MessageDlg('Error #' + inttostr(comErr) + ' during BuildCommDCB - Call MIS!',mtError,[mbOK], 0);
        close;
      end;

  try
    flgOpStatus := SetCommMask(hCommOut,(EV_RXCHAR) OR (EV_TXEMPTY));
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during SetCommMask - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during SetCommMask - Call MIS!',mtError,[mbOK], 0);
      close;
    end;


  try
    flgOpStatus := SetCommState(hCommOut,dcbOut);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error during SetCommState - Call MIS!', mtError,[mbOK],0);
        close;
      end
    else
      begin
        raise;
        close;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' during SetCommState - Call MIS!',mtError,[mbOK], 0);
      close;
    end;

end;

procedure TfrmMain.ReadCommData();
var InData: string;
    done: Boolean;
    InChar: PChar;
    flgEventStatus: Boolean;
    CommEvent: TCOMSTAT;
    CommErrors: DWORD;
    NumBytesRead: DWORD;
begin
  InChar := stralloc(2);
  InChar[1] := #0;
  done := False;
  lblInData.Caption := '* Received Data *' + #13#10;
  while done = False do
    begin
      flgEventStatus := ClearCommError(hCommIn,CommErrors,@CommEvent);
      if (CommEvent.cbInQue > 0) AND (flgEventStatus = True) then
        begin
          ReadFile(hCommIn,InChar[0],strlen(InChar),NumBytesRead,nil);
          InChar[1] := #0;
          if InChar[0] <> #13 then
            InData := InData + InChar[0];
        end
      else
        MessageDlg('Error reached End of Buffer before expected!', mtError,[mbOk], 0);
      lblInData.Caption := lblInData.Caption + InChar[0];
      lblInData.Refresh;
      if InChar[0] = #13 then
        begin
          flgEventStatus := ClearCommError(hCommIn,CommErrors,@CommEvent);
          if (CommEvent.cbInQue > 0) AND (flgEventStatus = True) then
            ReadFile(hCommIn,InChar[0],strlen(InChar),NumBytesRead,nil);
          InChar[1] := #0;
          done := True;
        end;
    end;
  Save_Data(InData);

  strdispose(InChar);
end;

function TfrmMain.GetToken(aString, SepChar: String; TokenNum: Byte):String;
{
parameters: aString : the complete string
            SepChar : a single character used as separator
                      between the substrings
            TokenNum: the number of the substring you want
result    : the substring or an empty string if the are less then
            'TokenNum' substrings
}
var
   Token     : String;
   StrLen    : Byte;
   TNum      : Byte;
   TEnd      : Byte;
begin
  StrLen := Length(aString);
  TNum   := 1;
  TEnd   := StrLen;
  while ((TNum <= TokenNum) and (TEnd <> 0)) do
    begin
      TEnd := Pos(SepChar,aString);
      if TEnd <> 0 then
        begin
          Token := Copy(aString,1,TEnd-1);
          Delete(aString,1,TEnd);
          Inc(TNum);
        end
      else
        begin
          Token := aString;
        end;
    end;

  if TNum >= TokenNum then
    begin
      Result := Token;
    end
  else
    begin
      Result := '';
    end;
end;

function TfrmMain.NumToken(aString, SepChar: String):Byte;
{
parameters: aString : the complete string
            SepChar : a single character used as separator
                      between the substrings
result    : the number of substrings
}
var RChar     : Char;
    StrLen    : Byte;
    TNum      : Byte;
    TEnd      : Byte;
begin
  if SepChar = '#' then
    begin
      RChar := '*'
    end
  else
    begin
      RChar := '#'
    end;

  StrLen := Length(aString);
  TNum   := 0;
  TEnd   := StrLen;
  while TEnd <> 0 do
    begin
      Inc(TNum);
      TEnd := Pos(SepChar,aString);
      if TEnd <> 0 then
        begin
          aString[TEnd] := RChar;
        end;
    end;

  Result := TNum;
end;

procedure TfrmMain.Save_Data(ParseData: String);
var nItemCount: Integer;
    strUnit,
    strComp: string;
begin
  nItemCount := 0;
  strUnit := '';
  strComp := '';

  if NumToken(ParseData,',') <> 2 then
    MessageDlg('Error parsing data from Intermec device! (Too many fields wide)', mtError,[mbOk], 0);

  strUnit := GetToken(ParseData,',',1);
  strComp := GetToken(ParseData,',',2);

  if (strUnit[1] = '&') AND (strUnit[1] <> '&') then
    MessageDlg('Error parsing data from Intermec device! (Compressor Bar Code NOT FOUND!)', mtError,[mbOk], 0)
  else if strUnit[1] = '&' then
    begin
      strComp := GetToken(ParseData,',',1);
      strUnit := GetToken(ParseData,',',2);
    end;

  strComp := copy(strComp,2,length(strComp)-1);

  with tblProd as TTable do
    begin
      Append;
      FieldByName('Unit').AsString := strUnit;
      FieldByName('Comp').AsString := strComp;
      FieldByName('TDate').AsDateTime := date;
      FieldByName('TTime').AsDateTime := Time;
    end;

 inc(intScanCount);
 lblScanCount.Caption := intToStr(intScanCount);

 lblComp.caption := strComp;
 lblUnit.caption := strUnit;
 Write_9512_Data(strUnit);
end;

procedure TfrmMain.Write_9512_Data(strUnitSerialNumber: String);
var NumBytesWritten: DWORD;
begin
  lblTitle9512.color := clWhite;
  lblTo9512.Caption := strUnitSerialNumber;
  strUnitSerialNumber := strUnitSerialNumber + #3;

  try
    if WriteFile(hCommOut,strUnitSerialNumber[1],length(strUnitSerialNumber),NumBytesWritten,nil) = False then
      MessageDlg('Error writing Unit Serial #' + strUnitSerialNumber + ' to 9512 - Call MIS!', mtError,[mbOK], 0);
  except
    raise;
  end;

  lblTitle9512.color := clLime;
end;

procedure TfrmMain.cmdExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.tmrPollComATimer(Sender: TObject);
var ReadChar: PChar;
    NumBytesRead: DWORD;
    flgEventStatus: Boolean;
    CommEvent: TCOMSTAT;
    CommErrors: DWORD;
    flgEmptyBuffer: Boolean;
begin
  flgEventStatus := ClearCommError(hCommIn,CommErrors,@CommEvent);
  if (CommEvent.cbInQue > 0) AND (flgEventStatus = True) then
    begin
      tmrPollComA.enabled := false;
      ReadCommData();
      flgEmptyBuffer := False;
      ReadChar := stralloc(2);
      while flgEmptyBuffer = False do
        try
          begin
            flgEventStatus := ClearCommError(hCommIn,CommErrors,@CommEvent);
            if (CommEvent.cbInQue > 0) AND (flgEventStatus = True) then
              ReadFile(hCommIn,ReadChar[0],strlen(ReadChar),NumBytesRead,nil)
            else
              flgEmptyBuffer := True;
          end;
        except
          raise;
        end;
      strdispose(ReadChar);
      tmrPollComA.enabled := True;
    end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var flgOpStatus: Boolean;
    comErr: DWORD;
begin
  tblProd.active := False;

  // Close the Input COM Port
  try
    flgOpStatus := CloseHandle(hCommIn);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error Closing Serial Port - Call MIS!', mtError,[mbOK], 0);
      end
    else
      begin
        raise;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' Closing Serial Port -Call MIS!', mtError,[mbOK], 0);
    end;

  // Close the Input COM Port
  try
    flgOpStatus := CloseHandle(hCommOut);
  except
    on X: EAccessViolation do
      begin
        MessageDlg('EAccessViolation Error Closing Serial Port - Call MIS!', mtError,[mbOK], 0);
      end
    else
      begin
        raise;
      end;
  end;

  if flgOpStatus = false then
    begin
      comErr := GetLastError();
      MessageDlg('Error #' + inttostr(comErr) + ' Closing Serial Port -Call MIS!', mtError,[mbOK], 0);
    end;
end;

end.
